
#include "convolute.h"

const struct Preset presets[] = {
    { GID_AVG_33, "Average3", 3, 0, 9,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,1,1,1,0,0 },
        { 0,0,1,1,1,0,0 },
        { 0,0,1,1,1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },
    { GID_AVG_55, "Average5", 5, 0, 25,
      {
        { 0,0,0,0,0,0,0 },
        { 0,1,1,1,1,1,0 },
        { 0,1,1,1,1,1,0 },
        { 0,1,1,1,1,1,0 },
        { 0,1,1,1,1,1,0 },
        { 0,1,1,1,1,1,0 },
        { 0,0,0,0,0,0,0 }
      }
    },
    { GID_AVG_77, "Average7", 7, 0, 49,
      {
        { 1,1,1,1,1,1,1 },
        { 1,1,1,1,1,1,1 },
        { 1,1,1,1,1,1,1 },
        { 1,1,1,1,1,1,1 },
        { 1,1,1,1,1,1,1 },
        { 1,1,1,1,1,1,1 },
        { 1,1,1,1,1,1,1 }
      }
    },

    { GID_BLUR4_33 , "Gauss4", 3, 0, 6,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,1,0,0,0 },
        { 0,0,1,2,1,0,0 },
        { 0,0,0,1,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_BLUR8_33 , "Gauss8", 3, 0, 16,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,1,2,1,0,0 },
        { 0,0,2,4,2,0,0 },
        { 0,0,1,2,1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_ROBERTS_1 , "Roberts 1", 3, 200, 1,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,1,0,0,0 },
        { 0,0,0,0,-1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_ROBERTS_2 , "Roberts 2", 3, 200, 1,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,1,0,0,0 },
        { 0,0,-1,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_LAPLACE_4 , "Laplace 4", 3, 128, 1,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,1,0,0,0 },
        { 0,0,1,-4,1,0,0 },
        { 0,0,0,1,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_LAPLACE_8 , "Laplace 8", 3, 128, 1,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,1,1,1,0,0 },
        { 0,0,1,-8,1,0,0 },
        { 0,0,1,1,1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_PREWITT_1 , "Prewitt 1", 3, 0, 6,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,1,1,1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,1,1,1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_PREWITT_2 , "Prewitt 2", 3, 0, 6,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,1,0,1,0,0 },
        { 0,0,1,0,1,0,0 },
        { 0,0,1,0,1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_SOBEL_1 , "Sobel 1", 3, 128, 8,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,1,2,1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,-1,-2,-1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_SOBEL_2 , "Sobel 2", 3, 128, 8,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,-1,0,1,0,0 },
        { 0,0,-2,0,2,0,0 },
        { 0,0,-1,0,1,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    { GID_KIRSCH_1 , "Kirsch 1", 3, 0, 1,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,3,3,3,0,0 },
        { 0,0,3,0,3,0,0 },
        { 0,0,-5,-5,-5,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },
    { GID_KIRSCH_2 , "Kirsch 2", 3, 0, 1,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,-5,3,3,0,0 },
        { 0,0,-5,0,3,0,0 },
        { 0,0,-5,3,3,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    },

    /* End table */

    { 0L , NULL, 3, 0, 9,
      {
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 },
        { 0,0,0,0,0,0,0 }
      }
    }
};

